/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TARMCOME_TRANSACCION_DETALLE")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findAll", query = "SELECT t FROM TarmcomeTransaccionDetalle t"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCoctrCodigo", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.tarmcomeTransaccionDetallePK.coctrCodigo = :coctrCodigo"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrCodigo", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.tarmcomeTransaccionDetallePK.codtrCodigo = :codtrCodigo"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByPetipNombre", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.petipNombre = :petipNombre"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCoarmCodigo", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.coarmCodigo = :coarmCodigo"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCoumeCodigo", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.coumeCodigo = :coumeCodigo"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCostaNombre", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.costaNombre = :costaNombre"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByDemdeCodigo", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.demdeCodigo = :demdeCodigo"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrCantidad", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrCantidad = :codtrCantidad"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrFechaDetalle", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrFechaDetalle = :codtrFechaDetalle"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrPersona", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrPersona = :codtrPersona"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrObservacion", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrObservacion = :codtrObservacion"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrPresentaArma", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrPresentaArma = :codtrPresentaArma"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrValor", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrValor = :codtrValor"),
    @NamedQuery(name = "TarmcomeTransaccionDetalle.findByCodtrDocumento", query = "SELECT t FROM TarmcomeTransaccionDetalle t WHERE t.codtrDocumento = :codtrDocumento")})
public class TarmcomeTransaccionDetalle implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TarmcomeTransaccionDetallePK tarmcomeTransaccionDetallePK;
    @Column(name = "PETIP_NOMBRE")
    private String petipNombre;
    @Column(name = "COARM_CODIGO")
    private String coarmCodigo;
    @Column(name = "COUME_CODIGO")
    private String coumeCodigo;
    @Column(name = "COSTA_NOMBRE")
    private String costaNombre;
    @Column(name = "DEMDE_CODIGO")
    private String demdeCodigo;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "CODTR_CANTIDAD")
    private BigDecimal codtrCantidad;
    @Column(name = "CODTR_FECHA_DETALLE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date codtrFechaDetalle;
    @Column(name = "CODTR_PERSONA")
    private String codtrPersona;
    @Column(name = "CODTR_OBSERVACION")
    private String codtrObservacion;
    @Column(name = "CODTR_PRESENTA_ARMA")
    private BigInteger codtrPresentaArma;
    @Column(name = "CODTR_VALOR")
    private BigDecimal codtrValor;
    @Column(name = "CODTR_DOCUMENTO")
    private String codtrDocumento;
    @JoinColumn(name = "COCTR_CODIGO", referencedColumnName = "COCTR_CODIGO", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private TarmcomeCabeceraTransaccion tarmcomeCabeceraTransaccion;

    public TarmcomeTransaccionDetalle() {
    }

    public TarmcomeTransaccionDetalle(TarmcomeTransaccionDetallePK tarmcomeTransaccionDetallePK) {
        this.tarmcomeTransaccionDetallePK = tarmcomeTransaccionDetallePK;
    }

    public TarmcomeTransaccionDetalle(String coctrCodigo, String codtrCodigo) {
        this.tarmcomeTransaccionDetallePK = new TarmcomeTransaccionDetallePK(coctrCodigo, codtrCodigo);
    }

    public TarmcomeTransaccionDetallePK getTarmcomeTransaccionDetallePK() {
        return tarmcomeTransaccionDetallePK;
    }

    public void setTarmcomeTransaccionDetallePK(TarmcomeTransaccionDetallePK tarmcomeTransaccionDetallePK) {
        this.tarmcomeTransaccionDetallePK = tarmcomeTransaccionDetallePK;
    }

    public String getPetipNombre() {
        return petipNombre;
    }

    public void setPetipNombre(String petipNombre) {
        this.petipNombre = petipNombre;
    }

    public String getCoarmCodigo() {
        return coarmCodigo;
    }

    public void setCoarmCodigo(String coarmCodigo) {
        this.coarmCodigo = coarmCodigo;
    }

    public String getCoumeCodigo() {
        return coumeCodigo;
    }

    public void setCoumeCodigo(String coumeCodigo) {
        this.coumeCodigo = coumeCodigo;
    }

    public String getCostaNombre() {
        return costaNombre;
    }

    public void setCostaNombre(String costaNombre) {
        this.costaNombre = costaNombre;
    }

    public String getDemdeCodigo() {
        return demdeCodigo;
    }

    public void setDemdeCodigo(String demdeCodigo) {
        this.demdeCodigo = demdeCodigo;
    }

    public BigDecimal getCodtrCantidad() {
        return codtrCantidad;
    }

    public void setCodtrCantidad(BigDecimal codtrCantidad) {
        this.codtrCantidad = codtrCantidad;
    }

    public Date getCodtrFechaDetalle() {
        return codtrFechaDetalle;
    }

    public void setCodtrFechaDetalle(Date codtrFechaDetalle) {
        this.codtrFechaDetalle = codtrFechaDetalle;
    }

    public String getCodtrPersona() {
        return codtrPersona;
    }

    public void setCodtrPersona(String codtrPersona) {
        this.codtrPersona = codtrPersona;
    }

    public String getCodtrObservacion() {
        return codtrObservacion;
    }

    public void setCodtrObservacion(String codtrObservacion) {
        this.codtrObservacion = codtrObservacion;
    }

    public BigInteger getCodtrPresentaArma() {
        return codtrPresentaArma;
    }

    public void setCodtrPresentaArma(BigInteger codtrPresentaArma) {
        this.codtrPresentaArma = codtrPresentaArma;
    }

    public BigDecimal getCodtrValor() {
        return codtrValor;
    }

    public void setCodtrValor(BigDecimal codtrValor) {
        this.codtrValor = codtrValor;
    }

    public String getCodtrDocumento() {
        return codtrDocumento;
    }

    public void setCodtrDocumento(String codtrDocumento) {
        this.codtrDocumento = codtrDocumento;
    }

    public TarmcomeCabeceraTransaccion getTarmcomeCabeceraTransaccion() {
        return tarmcomeCabeceraTransaccion;
    }

    public void setTarmcomeCabeceraTransaccion(TarmcomeCabeceraTransaccion tarmcomeCabeceraTransaccion) {
        this.tarmcomeCabeceraTransaccion = tarmcomeCabeceraTransaccion;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tarmcomeTransaccionDetallePK != null ? tarmcomeTransaccionDetallePK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TarmcomeTransaccionDetalle)) {
            return false;
        }
        TarmcomeTransaccionDetalle other = (TarmcomeTransaccionDetalle) object;
        if ((this.tarmcomeTransaccionDetallePK == null && other.tarmcomeTransaccionDetallePK != null) || (this.tarmcomeTransaccionDetallePK != null && !this.tarmcomeTransaccionDetallePK.equals(other.tarmcomeTransaccionDetallePK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.TarmcomeTransaccionDetalle[ tarmcomeTransaccionDetallePK=" + tarmcomeTransaccionDetallePK + " ]";
    }
    
}
